<?php

namespace Drupal\composable_editor_paragraphs\Form;

use Drupal\Core\Entity\ContentEntityForm;
use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Form\FormStateInterface;

/**
 * The ParagraphAddForm class.
 */
class ParagraphAddForm extends ContentEntityForm {

  /**
   * {@inheritdoc}
   *
   * Overridden to store the root parent entity.
   */
  public function buildForm(array $form, FormStateInterface $form_state, EntityInterface $root_parent = NULL, string $field = NULL) {
    $this->rootParent = $root_parent;
    $this->field = $field;

    return parent::buildForm($form, $form_state);
  }

  /**
   * {@inheritdoc}
   */
  public function save(array $form, FormStateInterface $form_state) {
    // Save the paragraph entity.
    $langcode = $this->rootParent->language()->getId();
    $this->entity->set('langcode', $langcode);
    $this->entity->save();

    // Save the node: paragraph parent entity.
    $this->rootParent->get($this->field)->appendItem($this->entity);
    $this->rootParent->save();

    return $this->entity;
  }

}
